#!/bin/ksh
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2007,2010 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
##############################################################
#
# end-to-end automation engine control script
#
# Input:
#       $1      action (<start|stop|status>)
#       $2      eez install directory
#       $3      engine EIF port (eif-receive-from-port)
#
# History:
#
#   11/07/2005  initial version                          as
#
##############################################################
#
# init section
# 
#

UNKNOWN=0
ONLINE=1
OFFLINE=2

Action=${1:-status}
INST_HOME=$2/bin
DMN_TCPP=$3

export PATH=$PATH:/bin:/usr/bin:/sbin:/usr/sbin:/usr/sbin/rsct/bin:${NA_HOME}/bin

OS=`uname`

case ${Action} in
        start)
                logger -i -p info -t $0 "end-to-end automation engine starting..."
                DMN_UP=`ps -ef | grep "EEZDmnServer" | grep -v grep`
                if [[ "${DMN_UP}" != "" ]]; then
                  RC=0
                  logger -i -p info -t $0 "end-to-end automation engine already started rc: ${RC}"
                else
                  ${INST_HOME}/eezdmn.sh -start >/dev/null 2>&1
                  RC=$?
                  if [[ $RC -ne 0 ]]; then 
                    RC=1
                  fi
                  logger -i -p info -t $0 "end-to-end automation engine start rc: ${RC}"
                fi
                ;;
        stop)
                logger -i -p info -t $0 "end-to-end automation engine stopping..."
                DMN_UP=`ps -ef | grep "EEZDmnServer" | grep -v grep`
                if [[ "X${DMN_UP}" = "X" ]]; then
                  RC=0
                  logger -i -p info -t $0 "end-to-end automation engine already stopped rc: ${RC}"
                else
                  ${INST_HOME}/eezdmn.sh -shutd >/dev/null 2>&1
                  RC=$?
                  if [[ $RC -eq 0 ]]; then
                    logger -i -p info -t $0 "end-to-end automation engine stop rc: ${RC}"
                  else
                    logger -i -p info -t $0 "end-to-end automation engine stop rc: ${RC}"
                    DMN_pid=`ps -ef | grep "EEZDmnServer" | grep -v grep | awk '{print $2}'`
                    kill -9 ${DMN_pid} > /dev/null 2>&1
                    logger -i -p info -t $0 "end-to-end automation engine (pid ${DMN_pid}) killed."
                    RC=0
                  fi
                fi
                ;;
        status)
                if [ "$OS" = "Linux" ]; then
                   DMN_UP=`netstat -lnt | grep :${DMN_TCPP}`
                else
                   DMN_UP=`netstat -an |grep LISTEN |grep tcp| grep .${DMN_TCPP}`
                fi
               
                if [[ "${DMN_UP}" != "" ]]; then
                  DMN_UP=`ps -ef | grep "EEZDmnServer" | grep -v grep`
                  if [[ "${DMN_UP}" != "" ]]; then
                    RC=$ONLINE
                  else
                    RC=$OFFLINE
                  fi
                else
                    RC=$OFFLINE
                fi
                ;;
        *)
                logger -i -p info -t $0 "Error: Incorrect parameter >${Action}<"
                RC=${UNKNOWN}
                ;;
esac

exit ${RC}

